/*
 File: subrules_phrasesym.cpp
 Date and Time: Fri Jan 30 18:55:25 2015 
*/
#include "subrules_phrase.h"
using namespace NS_yacco2_T_enum;// enumerate
using namespace NS_yacco2_err_symbols;// error symbols
using namespace NS_yacco2_k_symbols;// lrk 
using namespace NS_yacco2_terminals;// terminals
using namespace NS_yacco2_characters;// rc 
using namespace yacco2;// yacco2 library
using namespace NS_subrules_phrase;// grammar's ns
// first set terminals
yacco2::THR _YACCO2_CALL_TYPE
NS_subrules_phrase::TH_subrules_phrase(yacco2::Parser* Caller_pp){
  yacco2::Thread_entry& pp_thread_entry = ITH_subrules_phrase;
  NS_subrules_phrase::Csubrules_phrase Csubrules_phrase_;// parallel-parser's parse table
#define ssPARSE_TABLE Csubrules_phrase_
#include "wpp_core.h"
}
THR_result _YACCO2_CALL_TYPE
NS_subrules_phrase::PROC_TH_subrules_phrase(yacco2::Parser* Caller_pp){
  char called_proc_name[] = "PROC_TH_subrules_phrase";
  static bool one_time(false);
  static NS_subrules_phrase::Csubrules_phrase* NS_subrules_phrase_Csubrules_phrase_(0);// parallel-parser's fsm table
  static Parser* NS_subrules_phrase_Csubrules_phrase_parser(0);
  Parser* proc_parser(0);
  if(one_time == false){
    one_time = true;
    NS_subrules_phrase_Csubrules_phrase_ = new NS_subrules_phrase::Csubrules_phrase();// parallel-parser's fsm table
    NS_subrules_phrase_Csubrules_phrase_parser = new Parser(*NS_subrules_phrase_Csubrules_phrase_,Caller_pp);
  }
 proc_parser = NS_subrules_phrase_Csubrules_phrase_parser;
#include "wproc_pp_core.h"
}
void 
Csubrules_phrase::reduce_rhs_of_rule
    (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule){
   int reducing_rule = rhs_to_rules_mapping_[Sub_rule_no];
   Per_rule_s_reuse_table* rule_reuse_tbl_ptr = 
        fsm_rules_reuse_table.per_rule_s_table_[reducing_rule];
   Rule_s_reuse_entry* re(0);
   find_a_recycled_rule(rule_reuse_tbl_ptr,&re);
   (*Recycled_rule) = re;
   fnd_re: switch (Sub_rule_no){
    case rhs1_Rsubrules_phrase_:{
       Rsubrules_phrase* sym;
     if(re->rule_ == 0){
       sym = new Rsubrules_phrase(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rsubrules_phrase*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr1();
     return;}
    case rhs1_Rsubrule_defs_:{
       Rsubrule_defs* sym;
     if(re->rule_ == 0){
       sym = new Rsubrule_defs(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rsubrule_defs*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs2_Rsubrule_defs_:{
       Rsubrule_defs* sym;
     if(re->rule_ == 0){
       sym = new Rsubrule_defs(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rsubrule_defs*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 3;
    

     return;}
    case rhs1_Rsubrule_def_:{
       Rsubrule_def* sym;
     if(re->rule_ == 0){
       sym = new Rsubrule_def(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rsubrule_def*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs2_Rsubrule_def_:{
       Rsubrule_def* sym;
     if(re->rule_ == 0){
       sym = new Rsubrule_def(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rsubrule_def*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs3_Rsubrule_def_:{
       Rsubrule_def* sym;
     if(re->rule_ == 0){
       sym = new Rsubrule_def(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rsubrule_def*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr3();
     return;}
    case rhs1_Rsubrule_def1_:{
       Rsubrule_def1* sym;
     if(re->rule_ == 0){
       sym = new Rsubrule_def1(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rsubrule_def1*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs2_Rsubrule_def1_:{
       Rsubrule_def1* sym;
     if(re->rule_ == 0){
       sym = new Rsubrule_def1(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rsubrule_def1*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs1_Rlint_:{
       Rlint* sym;
     if(re->rule_ == 0){
       sym = new Rlint(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rlint*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs2_Rlint_:{
       Rlint* sym;
     if(re->rule_ == 0){
       sym = new Rlint(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rlint*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 0;
    

     return;}
    default: return;
   }
}
